package com.autentia.tutoriales.jbossesb.client;

import java.util.Properties;

import javax.jms.JMSException;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;



public class SendingMessageClient {
	
	 	private Queue queue;
	    private QueueSession queueSession;
	    private QueueConnection queueConnection;

	    public void startConnections() throws JMSException, NamingException {
	        Properties props = new Properties();
	        props.put(Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");
	        props.put(Context.URL_PKG_PREFIXES, "org.jboss.naming:org.jnp.interfaces");
	        props.put(Context.PROVIDER_URL, "jnp://127.0.0.1:1099");
	        InitialContext initialContext = new InitialContext(props);

	       
	        QueueConnectionFactory factory = (QueueConnectionFactory) initialContext.lookup("ConnectionFactory");
	        queueConnection = factory.createQueueConnection();
	        queue = (Queue) initialContext.lookup("queue/easyServiceGateway");
	        queueSession = queueConnection.createQueueSession(false, QueueSession.AUTO_ACKNOWLEDGE);
	        queueConnection.start();
	    }

	    public void stopConnections() throws JMSException { 
	        queueConnection.stop();
	        queueSession.close();
	        queueConnection.close();
	    }
	    
	    public void send(String msg) throws JMSException {
	        QueueSender send = queueSession.createSender(queue);        
	        ObjectMessage tm = queueSession.createObjectMessage(msg);
	        send.send(tm);
	        send.close();
	    }

	    public static void main(String args[]) throws Exception {
	        SendingMessageClient client = new SendingMessageClient();
	        client.startConnections();
	        client.send("Hola JBossESB"); 
	        client.stopConnections();
	    }

}
